diff -uwr sourceold/scripts/engine_phys.cpp source/scripts/engine_phys.cpp
--- sourceold/scripts/engine_phys.cpp	2011-10-22 20:22:09.932617100 +0800
+++ source/scripts/engine_phys.cpp	2012-05-12 19:20:40.911132800 +0800
@@ -26,11 +26,11 @@
 #include "VehicleGameObj.h"
 const char SCRIPTS_API *Get_Model(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return "DUMMY";
 	}
-	PhysicalGameObj *o = (PhysicalGameObj *)As_PhysicalGameObj(obj);
+	PhysicalGameObj *o = obj->As_PhysicalGameObj();
 	if (!o)
 	{
 		return "DUMMY";
@@ -38,522 +38,22 @@
 	return o->Peek_Physical_Object()->Peek_Model()->Get_Name();
 }
 
-bool SCRIPTS_API Is_TrackedVehicle(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x900C)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_VTOLVehicle(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x900D)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_WheeledVehicle(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9006)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_Motorcycle(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9002)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_Door(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9080)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_Elevator(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9081)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_DamageableStaticPhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9082)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_AccessablePhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9010)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_DecorationPhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9000)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_HumanPhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9001)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_MotorVehicle(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9003)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_Phys3(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9004)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_RigidBody(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9005)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_ShakeableStatricPhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x900F)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_StaticAnimPhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9008)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_StaticPhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9007)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_TimedDecorationPhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x900A)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_VehiclePhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x900B)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_DynamicAnimPhys(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x900E)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_BuildingAggregate(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9083)
-	{
-		return false;
-	}
-	return true;
-}
-
-bool SCRIPTS_API Is_Projectile(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return false;
-	}
-	GameObject *o = As_PhysicalGameObj(obj);
-	if (!o)
-	{
-		return false;
-	}
-	DefinitionClass* definition = Get_Phys_Definition(o);
-	if (!definition)
-	{
-		return false;
-	}
-	int Class_ID = definition->Get_Class_ID();
-	if (Class_ID != 0x9009)
-	{
-		return false;
-	}
-	return true;
-}
-
 //doesnt work for CinematicGameObjs
 float SCRIPTS_API Get_Animation_Frame(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o = obj->As_PhysicalGameObj();
 	if (!o)
 	{
 		return 0;
 	}
+	if (o->As_CinematicGameObj())
+	{
+		return 0;
+	}
 	unsigned char *x = (unsigned char *)o->Get_Anim_Control();
 	if (!x)
 	{
@@ -563,40 +63,18 @@
 	return a;
 }
 
-const char SCRIPTS_API *Get_Physics(GameObject *obj)
-{
-	if (Is_Door(obj)) return "Is_Door";
-	else if (Is_Elevator(obj)) return "Is_Elevator";
-	else if (Is_DamageableStaticPhys(obj)) return "Is_DamageableStaticPhys";
-	else if (Is_AccessablePhys(obj)) return "Is_AccessablePhys";
-	else if (Is_DecorationPhys(obj)) return "Is_DecorationPhys";
-	else if (Is_HumanPhys(obj)) return "Is_HumanPhys";
-	else if (Is_MotorVehicle(obj)) return "Is_MotorVehicle";
-	else if (Is_Phys3(obj)) return "Is_Phys3";
-	else if (Is_RigidBody(obj)) return "Is_RigidBody";
-	else if (Is_ShakeableStatricPhys(obj)) return "Is_ShakeableStatricPhys";
-	else if (Is_StaticAnimPhys(obj)) return "Is_StaticAnimPhys";
-	else if (Is_StaticPhys(obj)) return "Is_StaticPhys";
-	else if (Is_TimedDecorationPhys(obj)) return "Is_TimedDecorationPhys";
-	else if (Is_VehiclePhys(obj)) return "Is_VehiclePhys";
-	else if (Is_DynamicAnimPhys(obj)) return "Is_DynamicAnimPhys";
-	else if (Is_BuildingAggregate(obj)) return "Is_BuildingAggregate";
-	else if (Is_Projectile(obj)) return "Is_Projectile";
-	else return "(null)";
-}
-
 void SCRIPTS_API Copy_Transform(GameObject *in,GameObject *out)
 {
-	if (!Commands->Get_ID(in) || !in || !Commands->Get_ID(out) || !out)
+	if (!in || !out)
 	{
 		return;
 	}
-	PhysicalGameObj *i2 = ((ScriptableGameObj *)in)->As_PhysicalGameObj();
+	PhysicalGameObj *i2 = in->As_PhysicalGameObj();
 	if (!i2)
 	{
 		return;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)out)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = out->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return;
@@ -606,26 +84,30 @@
 
 float SCRIPTS_API Get_Mass(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o = (PhysicalGameObj *)As_PhysicalGameObj(obj);
+	PhysicalGameObj *o = obj->As_PhysicalGameObj();
 	if (!o)
 	{
 		return 0;
 	}
 	PhysClass *phys = o->Peek_Physical_Object();
+	if (phys && phys->As_MoveablePhysClass())
+	{
 	return phys->As_MoveablePhysClass()->Get_Mass();
 }
+	return 0;
+}
 
 const char SCRIPTS_API *Get_Htree_Name(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return "DUMMY";
 	}
-	PhysicalGameObj *o = (PhysicalGameObj *)As_PhysicalGameObj(obj);
+	PhysicalGameObj *o = obj->As_PhysicalGameObj();
 	if (!o)
 	{
 		return "DUMMY";
@@ -640,12 +122,10 @@
 
 void SCRIPTS_API Create_Effect_All_Stealthed_Objects_Area(const Vector3 &Position,float Distance,const char *object,const Vector3 &offset,int team)
 {
-	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
+	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
 	while (x) 
 	{
-		GameObject *obj = (GameObject *)x->Data();
-		if (obj && As_ScriptableGameObj(obj))
-		{
+		SmartGameObj *obj = x->Data();
 			Vector3 ObjPosition = Commands->Get_Position(obj);
 			Vector3 TestPosition = Position;
 			ObjPosition.Z = 0;
@@ -666,7 +146,6 @@
 					}
 				}
 			}
-		}
 		x = x->Next();
 	}
 }
@@ -697,3 +176,16 @@
 		x = x->Next();
 	}
 }
+
+
+SCRIPTS_API const char* Get_Animation_Name ( GameObject* pObj )
+{
+  if (!pObj || !pObj->As_PhysicalGameObj() || pObj->As_PhysicalGameObj()->As_CinematicGameObj())
+    return NULL;
+
+  AnimControlClass* pAcc = pObj->As_PhysicalGameObj()->Get_Anim_Control();
+  if ( pAcc )
+    return pAcc->Get_Animation_Name();
+  else
+    return NULL;
+}
diff -uwr sourceold/scripts/engine_phys.h source/scripts/engine_phys.h
--- sourceold/scripts/engine_phys.h	2011-10-11 21:53:38.783203100 +0800
+++ source/scripts/engine_phys.h	2012-05-12 19:20:40.888671800 +0800
@@ -15,32 +15,26 @@
 
 const char SCRIPTS_API *Get_Model(GameObject *obj); //get the name of the 3d model used by an object,opposite of Set_Model
 float SCRIPTS_API Get_Animation_Frame(GameObject *obj); //gets the current animation frame for obj,may not work for all objects
-bool SCRIPTS_API Is_TrackedVehicle(GameObject *obj); //has TrackedVechicle physics
-bool SCRIPTS_API Is_VTOLVehicle(GameObject *obj); //has VTOLVechicle physics
-bool SCRIPTS_API Is_WheeledVehicle(GameObject *obj); //has WheeledVechicle physics
-bool SCRIPTS_API Is_Motorcycle(GameObject *obj); //has Morotcycle physics
-bool SCRIPTS_API Is_Door(GameObject *obj); //has Door physics
-bool SCRIPTS_API Is_Elevator(GameObject *obj); //has Elevator physics
-bool SCRIPTS_API Is_DamageableStaticPhys(GameObject *obj); //has DamageableStaticPhys physics
-bool SCRIPTS_API Is_AccessablePhys(GameObject *obj); //has AccessablePhys physics
-bool SCRIPTS_API Is_DecorationPhys(GameObject *obj); //has DecorationPhys physics
-bool SCRIPTS_API Is_HumanPhys(GameObject *obj); //has HumanPhys physics
-bool SCRIPTS_API Is_MotorVehicle(GameObject *obj); //has MotorVehicle physics
-bool SCRIPTS_API Is_Phys3(GameObject *obj); //has Phys3 physics
-bool SCRIPTS_API Is_RigidBody(GameObject *obj); //has RigidBody physics
-bool SCRIPTS_API Is_ShakeableStatricPhys(GameObject *obj); //has ShakeableStaticPhys physics
-bool SCRIPTS_API Is_StaticAnimPhys(GameObject *obj); //has StaticAnimPhys physics
-bool SCRIPTS_API Is_StaticPhys(GameObject *obj); //has StaticPhys physics
-bool SCRIPTS_API Is_TimedDecorationPhys(GameObject *obj); //has TimedDecorationPhys physics
-bool SCRIPTS_API Is_VehiclePhys(GameObject *obj); //has VechiclePhys physics
-bool SCRIPTS_API Is_DynamicAnimPhys(GameObject *obj); //has DenamicAnimPhys physics
-bool SCRIPTS_API Is_BuildingAggregate(GameObject *obj); //has BuildingAggregate physics
-bool SCRIPTS_API Is_Projectile(GameObject *obj); //has Projectile physics
-const char SCRIPTS_API *Get_Physics(GameObject *obj); //returns a string indicating the physics type of an object
 void SCRIPTS_API Copy_Transform(GameObject *in,GameObject *out); //copies the complete transform (including rotation) from one object to another
 float SCRIPTS_API Get_Mass(GameObject *obj); //returns the mass of an object
 const char SCRIPTS_API *Get_Htree_Name(GameObject *obj); //returns the Hierarchy Tree name for an object
 char SCRIPTS_API Get_Sex(GameObject *obj); //gets the character (e.g. "A" for male or "B" for female) for use with animations
 void SCRIPTS_API Create_Effect_All_Stealthed_Objects_Area(const Vector3 &Position,float Distance,const char *object,const Vector3 &offset,int team); //creates an indicator object near every stealthed object in a given area
 void SCRIPTS_API Create_Effect_All_Of_Preset(const char *object,const char *preset,float ZAdjust,bool ZSet); //Create an object above all objects of a given preset, also set the facing to match the object its being created over.
+
+/*!
+* \brief Get current object animation
+* \author Daniel Paul (danpaul88@yahoo.co.uk)
+*
+* Get the name of the animation currently playing on the specified object, if any
+*
+* \param[in] pObj
+*   Pointer to the GameObject for which to get the current animation name
+*
+* \return
+*   The name of the current animation playing on the specified object or NULL if the object doesn't
+*   support animations or is not currently playing one
+*/
+SCRIPTS_API const char* Get_Animation_Name ( GameObject* pObj );
+
 #endif
diff -uwr sourceold/scripts/engine_player.cpp source/scripts/engine_player.cpp
--- sourceold/scripts/engine_player.cpp	2012-01-18 06:45:15.295898400 +0800
+++ source/scripts/engine_player.cpp	2012-05-23 15:23:26.239257800 +0800
@@ -22,6 +22,7 @@
 #include "engine_game.h"
 #include "engine_tdb.h"
 #include "SysTimeClass.h"
+#include "cTeam.h"
 RENEGADE_FUNCTION
 int SCRIPTS_API Get_Player_Count()
 AT2(0x00417040,0x00417040);
@@ -59,7 +60,7 @@
 AT2(0x00415810,0x00415810);
 
 RENEGADE_FUNCTION
-char *Find_Team(int team)
+cTeam *Find_Team(int team)
 AT2(0x0041DA10,0x0041DA10);
 
 RENEGADE_FUNCTION
@@ -68,11 +69,11 @@
 
 const char SCRIPTS_API *Get_Player_Name(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return newstr("None");
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (!o)
 	{
 		return newstr("None");
@@ -118,11 +119,11 @@
 
 void SCRIPTS_API Change_Team(GameObject *obj,int Team)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (!o)
 	{
 		return;
@@ -137,11 +138,11 @@
 
 void SCRIPTS_API Change_Team_2(GameObject *obj,int Team)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (!o)
 	{
 		return;
@@ -155,11 +156,11 @@
 
 long SCRIPTS_API Get_Player_ID(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return -1;
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (!o)
 	{
 		return -1;
@@ -260,11 +261,11 @@
 
 bool SCRIPTS_API Purchase_Item(GameObject *obj,int cost)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return false;
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (!o)
 	{
 		return false;
@@ -323,9 +324,12 @@
 
 float SCRIPTS_API Get_Team_Score(int team)
 {
-	char *teamdata = Find_Team(team);
-	teamdata += 0x6C0;
-	return *((float *)teamdata);
+	cTeam *teamdata = Find_Team(team);
+	if (teamdata)
+	{
+		return teamdata->Get_Score();
+	}
+	return 0;
 }
 
 void SCRIPTS_API Get_Team_Color(unsigned int team, unsigned int *red, unsigned int *green, unsigned int *blue)
@@ -338,11 +342,11 @@
 
 GameObject SCRIPTS_API *Find_First_Player(int Team)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
 		GameObject *o = x->Data();
-		if (o && As_SoldierGameObj(o))
+		if (o && (o))
 		{
 			if (Commands->Is_A_Star(o))
 			{
@@ -359,7 +363,7 @@
 
 bool SCRIPTS_API Change_Player_Team(GameObject *obj,bool Retain_Score,bool Retain_Money,bool Show_Host_Message)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return false;
 	}
@@ -409,13 +413,13 @@
 
 GameObject SCRIPTS_API *Get_Part_Name(const char *name1)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	int count = 0;
 	GameObject *current = 0;
 	while (x)
 	{
 		GameObject *o = x->Data();
-		if (o && As_SoldierGameObj(o))
+		if (o)
 		{
 			const char *name = Get_Player_Name(o);
 			if (stristr(name,name1))
@@ -439,12 +443,12 @@
 
 int SCRIPTS_API Get_Part_Names(const char *name1)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	int count = 0;
 	while (x)
 	{
 		GameObject *o = x->Data();
-		if (o && As_SoldierGameObj(o))
+		if (o)
 		{
 			const char *name = Get_Player_Name(o);
 			if (stristr(name,name1))
@@ -461,11 +465,11 @@
 int SCRIPTS_API Get_Team_Player_Count(int Team)
 {
 	int Total = 0;
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
 	while (x)
 	{
 		GameObject *o = x->Data();
-		if (o && As_SoldierGameObj(o) && Get_Object_Type(o) == Team)
+		if (o && Get_Object_Type(o) == Team)
 		{
 			Total++;
 		}
@@ -476,11 +480,11 @@
 
 int SCRIPTS_API Get_Player_Type(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (!o)
 	{
 		return 0;
@@ -494,11 +498,11 @@
 
 const wchar_t SCRIPTS_API *Get_Wide_Player_Name(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return L"None";
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (!o)
 	{
 		return L"None";
@@ -610,3 +614,78 @@
 		GameSpyAuthStateEntryTimeMs = TIMEGETTIME();
 	}
 }
+
+SCRIPTS_API int Get_Player_Team(int PlayerID)
+{
+        cPlayer *x = Find_Player(PlayerID);
+        if (!x)
+		{
+                return 0;
+        }
+        return x->PlayerType;
+}
+
+SCRIPTS_API int Get_Player_ID_By_Name(const char *Name)
+{
+        cPlayer *Player = Find_Player(Name);
+        if (Player)
+		{
+                return Player->Get_Id();
+        }
+        return 0;
+}
+
+SCRIPTS_API bool Is_Active(int ID)
+{
+        cPlayer *Player = Find_Player(ID);
+        if (Player)
+		{
+                return Player->Get_Is_Active();
+        }
+        return false;
+}
+
+SCRIPTS_API void Set_Kills(int ID,int kills)
+{
+        cPlayer *Player = Find_Player(ID);
+        if (Player)
+		{
+			Player->Set_Kills(kills);
+		}
+}
+
+SCRIPTS_API void Set_Deaths(int ID,int deaths)
+{
+        cPlayer *Player = Find_Player(ID);
+        if (Player)
+		{
+			Player->Set_Deaths(deaths);
+		}
+}
+
+SCRIPTS_API void Set_Team_Score(int ID,float score)
+{
+	cTeam *teamdata = Find_Team(ID);
+	if (teamdata)
+	{
+		teamdata->Set_Score(score);
+	}
+}
+
+void cPlayer::Set_Kills(int kills)
+{
+	Kills = kills;
+	Set_Object_Dirty_Bit(BIT_OCCASIONAL,true);
+}
+
+void cPlayer::Set_Deaths(int deaths)
+{
+	Deaths = deaths;
+	Set_Object_Dirty_Bit(BIT_OCCASIONAL,true);
+}
+
+void cTeam::Set_Score(float _score)
+{
+	score = _score;
+	Set_Object_Dirty_Bit(NetworkObjectClass::BIT_OCCASIONAL, true);
+}
diff -uwr sourceold/scripts/engine_player.h source/scripts/engine_player.h
--- sourceold/scripts/engine_player.h	2011-10-11 21:54:40.969726500 +0800
+++ source/scripts/engine_player.h	2012-05-23 11:10:50.924804600 +0800
@@ -48,9 +48,13 @@
 void SCRIPTS_API Change_Team_2(GameObject *obj,int Team); //changes the team of a player given their GameObject without killing the player,passing anything other than 0 = Nod,1 = GDI will crash
 int SCRIPTS_API Get_Player_Type(GameObject *obj); //Get the player type of a player from the cPlayer
 const wchar_t SCRIPTS_API *Get_Wide_Player_Name(GameObject *obj); //Converts a GameObject into a player name
-Vector3 SCRIPTS_API Get_Color_For_Team(int teamId);
-
-SCRIPTS_API cPlayer *Find_Player(int playerId);
-SCRIPTS_API cPlayer *Find_Player(const WideStringClass& playerName);
-
+Vector3 SCRIPTS_API Get_Color_For_Team(int teamId); //Get the color values for a team
+SCRIPTS_API int Get_Player_Team(int PlayerID); //Get the team type of a player
+SCRIPTS_API cPlayer *Find_Player(int playerId); //Find a player by ID
+SCRIPTS_API cPlayer *Find_Player(const WideStringClass& playerName); //find a player by name
+SCRIPTS_API int Get_Player_ID_By_Name(const char *Name); //Get the ID of a player given a name
+SCRIPTS_API bool Is_Active(int ID); //Is a player active
+SCRIPTS_API void Set_Kills(int ID,int kills); //Set kills for a player
+SCRIPTS_API void Set_Deaths(int ID,int deaths); //Set deaths for a player
+SCRIPTS_API void Set_Team_Score(int ID,float score); //Set score for a team
 #endif
